/**
 * @file EC_Proxy_Disconnector.cpp
 *
 * $Id: EC_Proxy_Disconnector.cpp 76589 2007-01-25 18:04:11Z elliott_c $
 *
 * @author Carlos O'Ryan <coryan@atdesk.com>
 */

#include "orbsvcs/Event/EC_Proxy_Disconnector.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

void
TAO_EC_Supplier_Proxy_Disconnect_Functor::operator() (
                       RtecEventComm::PushSupplier_ptr supplier)
  ACE_THROW_SPEC (())
{
  try
    {
      supplier->disconnect_push_supplier ();
    }
  catch (...)
    {
    }
}

void
TAO_EC_Consumer_Proxy_Disconnect_Functor::operator() (
                       RtecEventComm::PushConsumer_ptr consumer)
  ACE_THROW_SPEC (())
{
  try
    {
      consumer->disconnect_push_consumer ();
    }
  catch (...)
    {
    }
}

TAO_END_VERSIONED_NAMESPACE_DECL
